/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;



/**
 * In CBlock wird das Pseudopasswort und ein Timestamp für Webserviceaufrufe
 * gespeichert. CBlock erledigt die Authentifizierung und schützt vor
 * Replay-Angriffe.
 */
public class CBlock {

  public final static String PPASSWORD = Token.PPASSWORD;
  public final static String TIMESTAMP = "TIMESTAMP";

  private String pseudoPassword;
  private Long timestamp;

  public String getPseudoPassword() {
    return pseudoPassword;
  }



  public Long getTimestamp() {
    return timestamp;
  }



  /**
   * Das Pseudopasswort ist eine UUIDv4.
   * 
   * @param pseudoPassword
   *                       dieses Passwort
   */
  public void setPseudoPassword(String pseudoPassword) {
    this.pseudoPassword = pseudoPassword;
  }



  /**
   * Der Timestamp erledigt Authentifizierung und Replay-Schutz.
   * 
   * @param timestamp
   *                  Datum und Zeit in Millisekunden
   */
  public void setTimestamp(Long timestamp) {
    this.timestamp = timestamp;
  }



  public String toString() {
    GsonBuilder builder = new GsonBuilder();
    Gson gson = builder.registerTypeAdapter(CBlock.class, new CBlockSerializer()).create();
    return gson.toJson(this);
  }



  public static CBlock toCBlock(String deserialize) {
    GsonBuilder builder = new GsonBuilder();
    Gson gson = builder.registerTypeAdapter(CBlock.class, new CBlockDeserializer()).create();
    return gson.fromJson(deserialize, CBlock.class);
  }

}
